/**
 * Created by fides-WHK on 19.02.2018.
 */
$(document).ready(function () {
    var allTheTags = [];
    $("#nameProject").focus();
    $('#projectNameExists').hide();
    $('#projectIsMissing').hide();
    $('#exactNumberOfTags').hide();
    $(function () {
        $('#tagsProject').tagsInput({
            width: '475px',
            onAddTag: function (tag) {
                allTheTags.push(tag);
            },
            onRemoveTag: function (tag) {
                allTheTags.pop();           //todo: löscht noch nicht den gewählten tag sondern den letzten
            }
        });
    });
    $('#sendProject').on('click', function () {
        var activ = "1";
        createNewProject(allTheTags, activ);
    });
});


function createNewProject(allTheTags, activ) {
    var projectName = $("#nameProject").val().trim();
    var password = $("#passwordProject").val().trim();
    document.getElementById('loader').className = "loader";
    document.getElementById('wrapper').className = "wrapper-inactive";
    var localurl = "../database/getProjects.php?project=" + projectName;
    if (allTheTags.length !== 5) {
        document.getElementById('tagHelper').className = "alert alert-warning";
    } else {
        document.getElementById('tagHelper').className = "";
    }
    if (projectName === "") {           //project has no name, so abort function
        $('#projectIsMissing').show();
        return false;
    } else {
        $('#projectIsMissing').hide();
        $.ajax({                        //check local DB for existence of projectName
            url: localurl,
            projectName: projectName,
            activ: activ,
            Accept: "text/plain; charset=utf-8",
            contentType: "text/plain",
            success: function (response) {
                if (response !== "project missing") {
                    $('#projectNameExists').show();
                    document.getElementById('loader').className = "loader-inactive";
                    document.getElementById('wrapper').className = "wrapper";
                    return true;
                } else {
                    $('#projectNameExists').hide();
                    if (allTheTags.length !== 5) {
                        document.getElementById('tagHelper').className = "alert alert-warning";
                        document.getElementById('loader').className = "loader-inactive";
                        document.getElementById('wrapper').className = "wrapper";
                        $('#exactNumberOfTags').show();
                        return false;
                    }
                    document.getElementById('tagHelper').className = "";
                    var obj = {
                        "courseId": projectName,
                        "printableName": projectName,
                        "competences": allTheTags
                    };
                    var url = "https://esb.uni-potsdam.de:8243/services/competenceBase/api1/courses/" + $("#nameProject").val();
                    var dataString = JSON.stringify(obj);
                    var addProjectNeo4j = $.ajax({
                        url: url,
                        contentType: 'application/json',
                        activ: activ,
                        type: 'PUT',
                        data: dataString,
                        success: function (response) {
                            console.log(response);
                            document.getElementById('loader').className = "loader-inactive";
                            document.getElementById('wrapper').className = "wrapper";
                        },
                        error: function (a, b, c) {
                            console.log(a);
                            document.getElementById('loader').className = "loader-inactive";
                            document.getElementById('wrapper').className = "wrapper";
                            return false;
                        }
                    });
                    $.when(addProjectNeo4j, addProjectToLocalDB(allTheTags, projectName, password, activ)).done(function () {
                        document.getElementById('loader').className = "loader-inactive";
                        document.getElementById('wrapper').className = "wrapper";
                        if ($('#Teilnehmer').prop("checked")) {          //if author wants to join the course, he needs to be redirected to preferences.php
                            var url = "../database/getProjects.php?project=" + projectName + "&password=" + document.getElementById('passwordProject').value;
                            $.ajax({
                                url: url,
                                projectName: projectName,
                                Accept: "text/plain; charset=utf-8",
                                contentType: "text/plain",
                                success: function (response) {
                                    location.href = "preferences.php?token=" + getUserTokenFromUrl() + "&projectToken=" + response;
                                },
                                error: function (a, b, c) {
                                    console.log(a);
                                }
                            });
                        } else {                //if author is just author and not member, he will be directed to projects.php
                            location.href = "projects.php?token=" + getUserTokenFromUrl();
                        }
                    });
                }
            },
            error: function (a, b, c) {
                console.log(a);
                document.getElementById('loader').className = "loader-inactive";
                document.getElementById('wrapper').className = "wrapper";
                return true;
            }
        });
    }
}

function addProjectToLocalDB(allTheTags, projectName, password, activ) {
    var tags = JSON.stringify(allTheTags);
    var author = $("#user").text().trim();
    var adminPassword = $("#adminPassword").val();
    var url = "../database/putProject.php?project=" + projectName + "&password=" + password + "&activ=" + activ + "&token=" + getUserTokenFromUrl() + "&adminpassword=" + adminPassword + "&author=" + author;
    return $.ajax({
        url: url,
        //contentType: 'application/json',
        type: 'POST',
        data: tags,
        success: function (response) {
            console.log("Tags were added to local DB");
        },
        error: function (a, b, c) {
            console.log(a);
        }
    });
}